module Main where

import AbsSML
import Parser
import Printer
import IO
import List (sortBy)

import SMLtree
import WhiteRemover
--import ColorNest
--import Eval
--import RedundancyElim
import SortSharing
import PLshortcut

test str = do --instring <- getContents
	      let sml = whiteMerge $ whiteRemover $ parse str
	      let tree = ast2tree sml
	      let multi = tree2multi tree
	      let tree2 = multi2tree (plshortcut (sortSharing multi))
	      let ast = tree2ast tree2
	      Printer.print stdout ast

main = getContents >>= test
